

// This C++ file was created by SanEditor

#include "Atomic/simple/simpleSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         simpleSAN Constructor             
******************************************************************/


simpleSAN::simpleSAN(){


  Activity* InitialActionList[1]={
    &Timed_Activity1  // 0
  };

  BaseGroupClass* InitialGroupList[1]={
    (BaseGroupClass*) &(Timed_Activity1)
  };

  Place1 = new Place("Place1" ,20);
  Place2 = new Place("Place2" ,0);
  BaseStateVariableClass* InitialPlaces[2]={
    Place1,  // 0
    Place2   // 1
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("simple", 2, InitialPlaces, 
                        0, InitialROPlaces, 
                        1, InitialActionList, 1, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[2][2]={ 
    {0,0}, {1,0}
  };
  for(int n=0;n<2;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[1][2]={ 
    {0,0}
  };
  for(int n=0;n<1;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<1;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void simpleSAN::CustomInitialization() {

}
simpleSAN::~simpleSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void simpleSAN::assignPlacesToActivitiesInst(){
}
void simpleSAN::assignPlacesToActivitiesTimed(){
  Timed_Activity1.Place1 = (Place*) LocalStateVariables[0];
  Timed_Activity1.Place2 = (Place*) LocalStateVariables[1];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Timed_Activity1Activity========================*/

simpleSAN::Timed_Activity1Activity::Timed_Activity1Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Timed_Activity1",0,Exponential, RaceEnabled, 2,1, false);
}

simpleSAN::Timed_Activity1Activity::~Timed_Activity1Activity(){
  delete[] TheDistributionParameters;
}

void simpleSAN::Timed_Activity1Activity::LinkVariables(){
  Place1->Register(&Place1_Mobius_Mark);
  Place2->Register(&Place2_Mobius_Mark);
}

bool simpleSAN::Timed_Activity1Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Place1_Mobius_Mark)) >=1));
  return NewEnabled;
}

double simpleSAN::Timed_Activity1Activity::Rate(){
  return TestClass::CalculateRate(5.0, 2.0);
  return 1.0;  // default rate if none is specified
}

double simpleSAN::Timed_Activity1Activity::Weight(){ 
  return 1;
}

bool simpleSAN::Timed_Activity1Activity::ReactivationPredicate(){ 
  return false;
}

bool simpleSAN::Timed_Activity1Activity::ReactivationFunction(){ 
  return false;
}

double simpleSAN::Timed_Activity1Activity::SampleDistribution(){
  return TheDistribution->Exponential( TestClass::CalculateRate(5.0, 2.0));
}

double* simpleSAN::Timed_Activity1Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int simpleSAN::Timed_Activity1Activity::Rank(){
  return 1;
}

BaseActionClass* simpleSAN::Timed_Activity1Activity::Fire(){
  (*(Place1_Mobius_Mark))--;
  (*(Place2_Mobius_Mark))++;
  return this;
}

