#include "armPVModel.h"

armPVModel::armPVModel(bool expandTimeArrays) {
  TheModel=new simpleSAN();
  DefineName("armPVModel");
  CreatePVList(1, expandTimeArrays);
  Initialize();
}



PerformanceVariableNode* armPVModel::createPVNode(int pvindex, int timeindex) {
  switch(pvindex) {
  case 0:
    return new armPV0(timeindex);
    break;
  }
  return NULL;
}
