#include "armPVNodes.h"

armPV0Worker::armPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&simple);
}

armPV0Worker::~armPV0Worker() {
  delete [] TheModelPtr;
}

double armPV0Worker::Reward_Function(void) {

return simple->Place2->Mark();

return (0);



}

armPV0::armPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&ThesimpleSAN);
  double startpts[1]={2};
  double stoppts[1]={2};
  Initialize("rightVal",(RewardType)0,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("Place2","simple");
}

armPV0::~armPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void armPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new armPV0Worker;
}
