#ifndef _ARM_PVS_
#define _ARM_PVS_
#include "external/ExampleLibrary/TestClass.h"
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Atomic/simple/simpleSAN.h"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"


class armPV0Worker:public InstantOfTime
{
 public:
  simpleSAN *simple;
  
  armPV0Worker();
  ~armPV0Worker();
  double Reward_Function();
};

class armPV0:public PerformanceVariableNode
{
 public:
  simpleSAN *ThesimpleSAN;

  armPV0Worker *armPV0WorkerList;

  armPV0(int timeindex=0);
  ~armPV0();
  void CreateWorkerList(void);
};

#endif
